diff -urN ../VisualBoyAdvance-1.7.2/src/thumb.h ./src/thumb.h
--- ../VisualBoyAdvance-1.7.2/src/thumb.h	2004-05-13 22:50:06 +0900
+++ ./src/thumb.h	2006-06-25 05:21:47 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -17,6 +17,17 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+// The following define updates oldreg when debugger_last is activated
+
+#define UPDATE_OLD_REG \
+		   if (debugger_last) { \
+			   sprintf(oldbuffer,"%08x", armState ? reg[15].I - 4 : reg[15].I - 4); \
+			   for (xxx=0; xxx<18; xxx++){ \
+				   oldreg[xxx]=reg[xxx].I; \
+			   } \
+		   } 
+
+
 #ifdef C_CORE
 #define NEG(i) ((i) >> 31)
 #define POS(i) ((~(i)) >> 31)
@@ -763,16 +774,29 @@
 #endif
 #endif
 
-u32 opcode = CPUReadHalfWordQuick(armNextPC);
-clockTicks = thumbCycles[opcode >> 8] + memoryWaitFetch[(armNextPC >> 24) & 15];
+
+#ifdef BKPT_SUPPORT
+u8 xxx;
+#endif
+
+u32 opcode = cpuPrefetch[0];
+cpuPrefetch[0] = cpuPrefetch[1];
+
+busPrefetch = false;
+  if (busPrefetchCount & 0xFFFFFF00)
+    busPrefetchCount = 0x100 | (busPrefetchCount & 0xFF);
+
+clockTicks = 0;
+u32 oldArmNextPC = armNextPC;
 #ifndef FINAL_VERSION
 if(armNextPC == stop) {
-  armNextPC = armNextPC++;
+  armNextPC++;
 }
 #endif
 
 armNextPC = reg[15].I;
 reg[15].I += 2;
+THUMB_PREFETCH_NEXT;
 
 switch(opcode >> 8) {
  case 0x00:
@@ -901,54 +925,22 @@
    }
    break;
  case 0x20:
-   // MOV R0, #Offset8
-   reg[0].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[0].I ? false : true);
-   break;
  case 0x21:
-   // MOV R1, #Offset8
-   reg[1].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[1].I ? false : true);
-   break;   
  case 0x22:
-   // MOV R2, #Offset8
-   reg[2].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[2].I ? false : true);
-   break;   
  case 0x23:
-   // MOV R3, #Offset8
-   reg[3].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[3].I ? false : true);
-   break;   
  case 0x24:
-   // MOV R4, #Offset8
-   reg[4].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[4].I ? false : true);
-   break;   
  case 0x25:
-   // MOV R5, #Offset8
-   reg[5].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[5].I ? false : true);
-   break;   
  case 0x26:
-   // MOV R6, #Offset8
-   reg[6].I = opcode & 255;
-   N_FLAG = false;
-   Z_FLAG = (reg[6].I ? false : true);
-   break;   
  case 0x27:
-   // MOV R7, #Offset8
-   reg[7].I = opcode & 255;
+     {
+   u8 regist = (opcode >> 8) & 7;
+   // MOV R0~R7, #Offset8
+   reg[regist].I = opcode & 255;
    N_FLAG = false;
-   Z_FLAG = (reg[7].I ? false : true);
+   Z_FLAG = (reg[regist].I ? false : true);
+     }
    break;
- case 0x28:
+case 0x28:
    // CMP R0, #Offset8
    CMP_RN_O8(0);
    break;
@@ -1044,6 +1036,7 @@
    // SUB R7,#Offset8
    SUB_RN_O8(7);
    break;
+
  case 0x40:
    switch((opcode >> 6) & 3) {
    case 0x00:
@@ -1093,7 +1086,7 @@
        }
        N_FLAG = reg[dest].I & 0x80000000 ? true : false;
        Z_FLAG = reg[dest].I ? false : true;
-       clockTicks++;
+       clockTicks = codeTicksAccess16(armNextPC)+2;
      }
      break;
    case 0x03:
@@ -1115,7 +1108,7 @@
        }
        N_FLAG = reg[dest].I & 0x80000000 ? true : false;
        Z_FLAG = reg[dest].I ? false : true;
-       clockTicks++;
+       clockTicks = codeTicksAccess16(armNextPC)+2;
      }
      break;
    }
@@ -1144,7 +1137,7 @@
        }
        N_FLAG = reg[dest].I & 0x80000000 ? true : false;
        Z_FLAG = reg[dest].I ? false : true;
-       clockTicks++;
+       clockTicks = codeTicksAccess16(armNextPC)+2;
      }
      break;
    case 0x01:
@@ -1181,7 +1174,7 @@
            reg[dest].I = value;
          }
        }
-       clockTicks++;
+       clockTicks = codeTicksAccess16(armNextPC)+2;
        N_FLAG = reg[dest].I & 0x80000000 ? true : false;
        Z_FLAG = reg[dest].I ? false : true;
      }
@@ -1239,19 +1232,22 @@
    case 0x01:
      {
        // MUL Rd, Rs
+       clockTicks = 1;
        int dest = opcode & 7;
-       u32 rm = reg[(opcode >> 3) & 7].I;
-       reg[dest].I = reg[dest].I * rm;
+       u32 rm = reg[dest].I;
+       reg[dest].I = reg[(opcode >> 3) & 7].I * rm;
        if (((s32)rm) < 0)
          rm = ~rm;
        if ((rm & 0xFFFFFF00) == 0)
-         clockTicks += 1;
+         clockTicks += 0;
        else if ((rm & 0xFFFF0000) == 0)
-         clockTicks += 2;
+         clockTicks += 1;
        else if ((rm & 0xFF000000) == 0)
-         clockTicks += 3;
+         clockTicks += 2;
        else
-         clockTicks += 4;
+         clockTicks += 3;
+      busPrefetchCount = (busPrefetchCount<<clockTicks) | (0xFF>>(8-clockTicks));
+      clockTicks += codeTicksAccess16(armNextPC) + 1;
        Z_FLAG = reg[dest].I ? false : true;
        N_FLAG = reg[dest].I & 0x80000000 ? true : false;
      }
@@ -1294,7 +1290,9 @@
          reg[15].I &= 0xFFFFFFFE;
          armNextPC = reg[15].I;
          reg[15].I += 2;
-         clockTicks++;
+         THUMB_PREFETCH;
+         clockTicks = codeTicksAccessSeq16(armNextPC)+1;
+         clockTicks += clockTicks+codeTicksAccess16(armNextPC)+1;
        }       
        break;
      case 3:
@@ -1304,7 +1302,9 @@
          reg[15].I &= 0xFFFFFFFE;
          armNextPC = reg[15].I;
          reg[15].I += 2;
-         clockTicks++;     
+         THUMB_PREFETCH;
+         clockTicks = codeTicksAccessSeq16(armNextPC)+1;
+         clockTicks += clockTicks+codeTicksAccess16(armNextPC)+1;     
        }
        break;
      }
@@ -1359,20 +1359,33 @@
        // MOV Hd, Rs
        reg[dest+8].I = reg[base].I;
        if(dest == 7) {
+#ifdef BKPT_SUPPORT
+	     UPDATE_OLD_REG
+#endif
+
          reg[15].I &= 0xFFFFFFFE;
          armNextPC = reg[15].I;
          reg[15].I += 2;
-         clockTicks++;
+         THUMB_PREFETCH;
+         clockTicks = codeTicksAccessSeq16(armNextPC)+1;
+         clockTicks += clockTicks+codeTicksAccess16(armNextPC)+1; 
        }
        break;
      case 3:
        // MOV Hd, Hs
        reg[dest+8].I = reg[base+8].I;
        if(dest == 7) {
+
+#ifdef BKPT_SUPPORT
+	     UPDATE_OLD_REG
+#endif
+
          reg[15].I &= 0xFFFFFFFE;
          armNextPC = reg[15].I;
          reg[15].I += 2;
-         clockTicks++;
+         THUMB_PREFETCH;
+         clockTicks = codeTicksAccessSeq16(armNextPC)+1;
+         clockTicks += clockTicks+codeTicksAccess16(armNextPC)+1; 
        }   
        break;
      }
@@ -1381,33 +1394,54 @@
  case 0x47:
    {
      int base = (opcode >> 3) & 7;
+     busPrefetchCount=0;
      switch((opcode >>6) & 3) {
      case 0:
        // BX Rs
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
        reg[15].I = (reg[base].I) & 0xFFFFFFFE;
        if(reg[base].I & 1) {
          armState = false;
          armNextPC = reg[15].I;
          reg[15].I += 2;
+         THUMB_PREFETCH;
+         clockTicks = codeTicksAccessSeq16(armNextPC) +
+             codeTicksAccessSeq16(armNextPC) + codeTicksAccess16(armNextPC) + 3;
        } else {
          armState = true;
          reg[15].I &= 0xFFFFFFFC;
          armNextPC = reg[15].I;
          reg[15].I += 4;
+         ARM_PREFETCH;
+         clockTicks = codeTicksAccessSeq32(armNextPC) +
+             codeTicksAccessSeq32(armNextPC) + codeTicksAccess32(armNextPC) + 3;
        }
        break;
      case 1:
        // BX Hs
+
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
+
        reg[15].I = (reg[8+base].I) & 0xFFFFFFFE;
        if(reg[8+base].I & 1) {
          armState = false;
          armNextPC = reg[15].I;
          reg[15].I += 2;
+         THUMB_PREFETCH;
+         clockTicks = dataTicksAccess16(armNextPC) + dataTicksAccess16(armNextPC) +
+             codeTicksAccess16(armNextPC) + 3;
        } else {
          armState = true;
          reg[15].I &= 0xFFFFFFFC;       
          armNextPC = reg[15].I;
          reg[15].I += 4;
+         ARM_PREFETCH;
+         clockTicks = dataTicksAccess32(armNextPC) + dataTicksAccess32(armNextPC) +
+             codeTicksAccess32(armNextPC) + 3;
        }
        break;
      default:
@@ -1416,143 +1450,119 @@
    }
    break;
  case 0x48:
-   // LDR R0,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);
-     reg[0].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);
-   }
-   break;
  case 0x49:
-   // LDR R1,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);   
-     reg[1].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);
-   }
-   break;
  case 0x4a:
-   // LDR R2,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[2].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x4b:
-   // LDR R3,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[3].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x4c:
-   // LDR R4,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[4].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x4d:
-   // LDR R5,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[5].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x4e:
-   // LDR R6,[PC, #Imm]
-   {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[6].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x4f:
-   // LDR R7,[PC, #Imm]
+   // LDR R0~R7,[PC, #Imm]
    {
-     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);      
-     reg[7].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
+   u8 regist = (opcode >> 8) & 7;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
+     u32 address = (reg[15].I & 0xFFFFFFFC) + ((opcode & 0xFF) << 2);
+     reg[regist].I = CPUReadMemoryQuick(address);
+     busPrefetchCount=0;
+     clockTicks = 3 + dataTicksAccess32(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x50:
  case 0x51:
    // STR Rd, [Rs, Rn]
    {
-     u32 
-       address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
+     u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      CPUWriteMemory(address,
                     reg[opcode & 7].I);
-     clockTicks += CPUUpdateTicksAccess32(address);
+     clockTicks = dataTicksAccess32(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;
  case 0x52:
  case 0x53:
    // STRH Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      CPUWriteHalfWord(address,
                       reg[opcode&7].W.W0);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = dataTicksAccess16(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;
  case 0x54:
  case 0x55:
    // STRB Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode >>6)&7].I;
      CPUWriteByte(address,
                   reg[opcode & 7].B.B0);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = dataTicksAccess16(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;
  case 0x56:
  case 0x57:
    // LDSB Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      reg[opcode&7].I = (s8)CPUReadByte(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess16(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x58:
  case 0x59:
    // LDR Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      reg[opcode&7].I = CPUReadMemory(address);
-     clockTicks += CPUUpdateTicksAccess32(address);
+     clockTicks = 3 + dataTicksAccess32(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x5a:
  case 0x5b:
    // LDRH Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      reg[opcode&7].I = CPUReadHalfWord(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess32(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x5c:
  case 0x5d:
    // LDRB Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      reg[opcode&7].I = CPUReadByte(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess16(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x5e:
  case 0x5f:
    // LDSH Rd, [Rs, Rn]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + reg[(opcode>>6)&7].I;
      reg[opcode&7].I = (s16)CPUReadHalfWordSigned(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess16(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x60:
@@ -1565,10 +1575,12 @@
  case 0x67:
    // STR Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31)<<2);
      CPUWriteMemory(address,
                     reg[opcode&7].I);
-     clockTicks += CPUUpdateTicksAccess32(address);
+     clockTicks = dataTicksAccess32(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;
  case 0x68:
@@ -1581,9 +1593,12 @@
  case 0x6f:
    // LDR Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31)<<2);
      reg[opcode&7].I = CPUReadMemory(address);
-     clockTicks += CPUUpdateTicksAccess32(address);
+     clockTicks = 3 + dataTicksAccess32(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x70:
@@ -1596,10 +1611,12 @@
  case 0x77:
    // STRB Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31));
      CPUWriteByte(address,
                   reg[opcode&7].B.B0);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = dataTicksAccess16(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;
  case 0x78:
@@ -1612,9 +1629,12 @@
  case 0x7f:
    // LDRB Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31));
      reg[opcode&7].I = CPUReadByte(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess16(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x80:
@@ -1627,10 +1647,12 @@
  case 0x87:
    // STRH Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31)<<1);
      CPUWriteHalfWord(address,
                       reg[opcode&7].W.W0);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = dataTicksAccess16(address) + codeTicksAccess16(armNextPC) + 2;
    }
    break;   
  case 0x88:
@@ -1643,203 +1665,79 @@
  case 0x8f:
    // LDRH Rd, [Rs, #Imm]
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[(opcode>>3)&7].I + (((opcode>>6)&31)<<1);
      reg[opcode&7].I = CPUReadHalfWord(address);
-     clockTicks += CPUUpdateTicksAccess16(address);
+     clockTicks = 3 + dataTicksAccess16(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0x90:
-   // STR R0, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);
-     CPUWriteMemory(address, reg[0].I);
-     clockTicks += CPUUpdateTicksAccess32(address);
-   }
-   break;      
  case 0x91:
-   // STR R1, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[1].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x92:
-   // STR R2, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[2].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x93:
-   // STR R3, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[3].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x94:
-   // STR R4, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[4].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x95:
-   // STR R5, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[5].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x96:
-   // STR R6, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[6].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;      
  case 0x97:
-   // STR R7, [SP, #Imm]
+   // STR R0~R7, [SP, #Imm]
    {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     CPUWriteMemory(address, reg[7].I);
-     clockTicks += CPUUpdateTicksAccess32(address);   
+   u8 regist = (opcode >> 8) & 7;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
+     u32 address = reg[13].I + ((opcode&255)<<2);
+     CPUWriteMemory(address, reg[regist].I);
+     clockTicks = dataTicksAccess32(address) + codeTicksAccess16(armNextPC) + 2;
    }
-   break;   
+   break;      
  case 0x98:
-   // LDR R0, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[0].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x99:
-   // LDR R1, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[1].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9a:
-   // LDR R2, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[2].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9b:
-   // LDR R3, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[3].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9c:
-   // LDR R4, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[4].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9d:
-   // LDR R5, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[5].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9e:
-   // LDR R6, [SP, #Imm]
-   {
-     u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[6].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
-   }
-   break;
  case 0x9f:
-   // LDR R7, [SP, #Imm]
+   // LDR R0~R7, [SP, #Imm]
    {
+   u8 regist = (opcode >> 8) & 7;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      u32 address = reg[13].I + ((opcode&255)<<2);   
-     reg[7].I = CPUReadMemoryQuick(address);
-     clockTicks += CPUUpdateTicksAccess32(address);   
+     reg[regist].I = CPUReadMemoryQuick(address);
+     clockTicks = 3 + dataTicksAccess32(address) +
+         codeTicksAccess16(armNextPC);
    }
    break;
  case 0xa0:
-   // ADD R0, PC, Imm
-   reg[0].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa1:
-   // ADD R1, PC, Imm
-   reg[1].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa2:
-   // ADD R2, PC, Imm
-   reg[2].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa3:
-   // ADD R3, PC, Imm
-   reg[3].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa4:
-   // ADD R4, PC, Imm
-   reg[4].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa5:
-   // ADD R5, PC, Imm
-   reg[5].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa6:
-   // ADD R6, PC, Imm
-   reg[6].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
-   break;   
  case 0xa7:
-   // ADD R7, PC, Imm
-   reg[7].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
+     {
+   // ADD R0~R7, PC, Imm
+   u8 regist = (opcode >> 8) & 7;
+   reg[regist].I = (reg[15].I & 0xFFFFFFFC) + ((opcode&255)<<2);
+     }
    break;   
  case 0xa8:
-   // ADD R0, SP, Imm
-   reg[0].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xa9:
-   // ADD R1, SP, Imm
-   reg[1].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xaa:
-   // ADD R2, SP, Imm
-   reg[2].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xab:
-   // ADD R3, SP, Imm
-   reg[3].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xac:
-   // ADD R4, SP, Imm
-   reg[4].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xad:
-   // ADD R5, SP, Imm
-   reg[5].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xae:
-   // ADD R6, SP, Imm
-   reg[6].I = reg[13].I + ((opcode&255)<<2);
-   break;   
  case 0xaf:
-   // ADD R7, SP, Imm
-   reg[7].I = reg[13].I + ((opcode&255)<<2);
-   break;   
+     {
+   // ADD R0~R7, SP, Imm
+   u8 regist = (opcode >> 8) & 7;
+   reg[regist].I = reg[13].I + ((opcode&255)<<2);
+     }
+   break;     
  case 0xb0:
    {
      // ADD SP, Imm
@@ -1853,15 +1751,17 @@
   if(opcode & (val)) {\
     CPUWriteMemory(address, reg[(r)].I);\
     if(offset)\
-      clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     else\
-      clockTicks += 1 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
     offset = 1;\
     address += 4;\
   }
  case 0xb4:
    // PUSH {Rlist}
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      int offset = 0;
      u32 temp = reg[13].I - 4 * cpuBitsSet[opcode & 0xff];
      u32 address = temp & 0xFFFFFFFC;
@@ -1873,12 +1773,15 @@
      PUSH_REG(32, 5);
      PUSH_REG(64, 6);
      PUSH_REG(128, 7);
+     clockTicks += codeTicksAccess16(armNextPC)+1;
      reg[13].I = temp;
    }
    break;
  case 0xb5:
    // PUSH {Rlist, LR}
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      int offset = 0;
      u32 temp = reg[13].I - 4 - 4 * cpuBitsSet[opcode & 0xff];
      u32 address = temp & 0xFFFFFFFC;
@@ -1891,6 +1794,7 @@
      PUSH_REG(64, 6);
      PUSH_REG(128, 7);
      PUSH_REG(256, 14);
+     clockTicks += codeTicksAccess16(armNextPC)+1;
      reg[13].I = temp;
    }
    break;
@@ -1898,18 +1802,21 @@
   if(opcode & (val)) {\
     reg[(r)].I = CPUReadMemory(address);\
     if(offset)\
-      clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     else\
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
     offset = 1;\
     address += 4;\
   }
  case 0xbc:
    // POP {Rlist}
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      int offset = 0;
      u32 address = reg[13].I & 0xFFFFFFFC;
      u32 temp = reg[13].I + 4*cpuBitsSet[opcode & 0xFF];
+     clockTicks = 0;
      POP_REG(1, 0);
      POP_REG(2, 1);
      POP_REG(4, 2);
@@ -1919,14 +1826,18 @@
      POP_REG(64, 6);
      POP_REG(128, 7);
      reg[13].I = temp;
+     clockTicks += codeTicksAccess16(armNextPC)+2;
    }
    break;   
  case 0xbd:
    // POP {Rlist, PC}
    {
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
      int offset = 0;
      u32 address = reg[13].I & 0xFFFFFFFC;
      u32 temp = reg[13].I + 4 + 4*cpuBitsSet[opcode & 0xFF];
+     clockTicks = 0;
      POP_REG(1, 0);
      POP_REG(2, 1);
      POP_REG(4, 2);
@@ -1937,12 +1848,15 @@
      POP_REG(128, 7);
      reg[15].I = (CPUReadMemory(address) & 0xFFFFFFFE);
      if(offset)
-       clockTicks += CPUUpdateTicksAccessSeq32(address);
+       clockTicks += 1 + dataTicksAccessSeq32(address);
      else
-       clockTicks += CPUUpdateTicksAccess32(address);
+       clockTicks += 1 + dataTicksAccess32(address);
      armNextPC = reg[15].I;
      reg[15].I += 2;
      reg[13].I = temp;
+     THUMB_PREFETCH;
+     busPrefetchCount=0;
+     clockTicks += codeTicksAccess16(armNextPC) + codeTicksAccess16(armNextPC) + 3;
    }
    break;      
 #define THUMB_STM_REG(val,r,b) \
